<?php

namespace App\DataTables;

use App\Models\Dispositivo;
use App\Models\Attivita;
use Illuminate\Database\Eloquent\Builder as QueryBuilder;
use Yajra\DataTables\EloquentDataTable;
use Yajra\DataTables\Html\Builder as HtmlBuilder;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;
use Illuminate\Support\Facades\Auth;

class StampanteDataTable extends DataTable
{
    public function __construct()
    {
        $this->dataTableVariable = 'dataTable_stampante';
    }
    /**
     * Build the DataTable class.
     *
     * @param QueryBuilder<Dispositivo> $query Results from query() method.
     */
    public function dataTable(QueryBuilder $query): EloquentDataTable
    {
        return (new EloquentDataTable($query))
            ->addColumn('action', function($entity){
                return view('stampante.menu', ['entity' => $entity]);
            })
            ->addColumn('is_attivo_display', function($entity){
                return view('_partials.available', ['available' => $entity->is_attivo]);
            })
            ->addColumn('attivita_id_display', function($entity){
                return $entity->attivita ? $entity->attivita->nome : 'ND';
            })
            ->addColumn('occupato_display', function($entity){
                return view('_partials.available', ['available' => $entity->occupato()]);
            })
            ->addColumn('tipo_display', function($entity){
                return '<i class="'.Dispositivo::getTipoDispositivo()->get($entity->tipo)['icon'].'"></i> '.Dispositivo::getTipoDispositivo()->get($entity->tipo)['label'];
            })
            ->rawColumns(['tipo_display'])
            ->setRowId('id');
    }

    /**
     * Get the query source of dataTable.
     *
     * @return QueryBuilder<Dispositivo>
     */
    public function query(Dispositivo $model): QueryBuilder
    {
        if($this->attivita_id){
            return $model->newQuery()->where('tipo', Dispositivo::STAMPANTE)->where('attivita_id', $this->attivita_id);
        }else{
            return $model->newQuery()->where(' 1 = 0');
        }

    }

    /**
     * Optional method if you want to use the html builder.
     */
    public function html(): HtmlBuilder
    {
        $buttons = [];
        if(Auth::user()->can('create-stampante')){
            array_push($buttons, Button::make('create')
                ->editor('editor')
                ->className('btn btn-sm btn-primary mb-4')
                ->formTitle('Crea nuovo stampante')
                ->text('<i class="fas fa-plus"></i> Nuova stampante'));
        }

        if(Auth::user()->can('edit-stampante')){
            array_push($buttons, Button::raw('<button class="btn btn-sm btn-warning mb-4" onclick="api_updateStampanti()">Aggiorna stampanti (API)</button>'));
        }

        return $this->builder()
                    ->setTableId($this->dataTableVariable)
                    ->columns($this->getColumns())
                    ->minifiedAjax()
                    ->language(asset('assets/Italian.json'))
                    ->dom(count($buttons) == 0 ? 'rtip' : 'Bfrtip')
                    ->buttons($buttons)
                    ->orderBy(1)
                    ->editor(
                        Editor::make()
                            ->fields([
                                Fields\Text::make('nome')->label('Nome'),
                                Fields\Hidden::make('tipo')->label('Tipo')->default(Dispositivo::STAMPANTE),
                                Fields\Select2::make('attivita_id')->label('Attività')->options(Attivita::where('is_attiva', true)->pluck('id', 'nome')),
                                Fields\Text::make('licenza')->label('Licenza'),
                                Fields\Text::make('url_stampante')->label('URL della stampante'),
                                Fields\Text::make('ubicazione')->label('Ubicazione'),
                                Fields\Text::make('note')->label('Note'),
                                Fields\Boolean::make('is_attivo')->label('Attivo')->default(true),
                                Fields\Text::make('pin_sblocco')->label('Pin di sblocco'),
                                Fields\DateTime::make('data_apertura_dispositivo')->label('Data di apertura del dispositivo'),
                                Fields\DateTime::make('data_chiusura_dispositivo')->label('Data di chiusura del dispositivo'),
                            ])
                    )
                    ->initComplete("function(settings, json){
                        initComplete_stampante();
                    }")
                    ->selectStyleSingle();
    }

    /**
     * Get the dataTable columns definition.
     */
    public function getColumns(): array
    {
        return [
            Column::make('id')->visible(false),
            Column::make('is_attivo')->data('is_attivo_display')->title('Disponibile'),
            Column::make('nome')->title('Nome'),
            Column::make('attivita_id')->title('Attività')->data('attivita_id_display'),
            Column::make('occupato')->data('occupato_display')->title('Occupato'),
            Column::make('tipo')->title('Tipo')->data('tipo_display'),
            Column::make('licenza')->title('Licenza'),
            Column::make('url_stampante')->title('URL della stampante'),
            Column::make('ubicazione')->title('Ubicazione'),
            // Column::make('note')->title('Note'),
            Column::make('pin_sblocco')->title('Pin di sblocco'),
            // Column::make('data_apertura_dispositivo')->title('Data di apertura del dispositivo'),
            // Column::make('data_chiusura_dispositivo')->title('Data di chiusura del dispositivo'),
            Column::computed('action')
                  ->title('')
                  ->exportable(false)
                  ->printable(false)
                  ->width(60)
                  ->addClass('text-center'),
        ];
    }

    /**
     * Get the filename for export.
     */
    protected function filename(): string
    {
        return 'Dispositivo_' . date('YmdHis');
    }
}
